#ifndef _RATIONNEL_HPP_
#define _RATIONNEL_HPP_

#include <iostream>
#include <cmath>



int pgcd(int a, int b); // On declare la fonction pgcd



// La declaration de la classe "rationnel"
class rationnel
{
private:
  int denom, num;

public:
  rationnel(int n=0, int d=1);
  /* Le constructeur du rationnel n/d a partir des valeurs de n et d. Les valeurs par defaut
	 correspondent au rationnel 0. Si on ne donne que le parametre n, on obtient le rationnel
	 n/1, ce qui correspond bien a convertir un entier en rationnel.
  */


  // La classe rationnel n'a pas de champ de type pointeur. Il n'est donc pas necessaire de redefinir l'operateur =, le constructeur par copie et le destructeur.

  double valeur(void) const // La valeur numerique du rationnel.
  {	return (double)num/denom; }
  
  rationnel operator-(void) const // L'operateur - unaire (c'est-a-dire qui a x associe -x)
   {	return rationnel(-num,denom); }


  // Les operateurs binaires +,-,*,/ et les operateurs d'affectation correspondants. 
  friend rationnel operator+(rationnel const &q1, rationnel const &q2);
  rationnel& operator+=(rationnel const &q);

  friend rationnel operator-(rationnel const &q1, rationnel const &q2);
  rationnel& operator-=(rationnel const &q);

  friend rationnel operator*(rationnel const &q1, rationnel const &q2);
  rationnel& operator*=(rationnel const &q);

  friend rationnel operator/(rationnel const &q1, rationnel const &q2);
  rationnel& operator/=(rationnel const &q);

  
  // Affichage
  friend std::ostream& operator<<(std::ostream& o, rationnel const &q);
};


#endif /* _RATIONNEL_HPP_ */
